package com.casic.dcms.vm;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.base.BaseApplication;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.LoginResultBean;
import com.casic.dcms.model.UserBean;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.callback.OnObserverCallback;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.SaveKeyValues;
import com.pengxh.androidx.lite.vm.BaseViewModel;
import com.pengxh.androidx.lite.vm.LoadState;
import com.pengxh.androidx.lite.vm.ObserverSubscriber;

import java.io.IOException;
import java.net.ConnectException;

import okhttp3.ResponseBody;
import rx.Observable;

public class UserViewModel extends BaseViewModel {
    private static final String TAG = "UserViewModel";
    private final Gson gson = new Gson();
    public MutableLiveData<UserBean> userDataResult = new MutableLiveData<>();
    public MutableLiveData<LoginResultBean> loginResult = new MutableLiveData<>();
    public MutableLiveData<ActionResultBean> loginOutResult = new MutableLiveData<>();
    public MutableLiveData<ActionResultBean> changePwdResult = new MutableLiveData<>();

    public void getUserData() {
        Observable<ResponseBody> observable = RetrofitServiceManager.getUserData();
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        UserBean userBean = gson.fromJson(response, new TypeToken<UserBean>() {
                        }.getType());
                        userDataResult.setValue(userBean);
                        SaveKeyValues.putValue(LocaleConstant.USER_DETAIL_MODEL, gson.toJson(userBean.getData()));
                    } else {
                        UserBean errorModel = new UserBean();
                        errorModel.setCode(responseCode);
                        userDataResult.setValue(errorModel);
                        //如果此次获取不到用户信息，那么就清空之前的用户缓存，然后让用户重新登录
                        SaveKeyValues.removeKey(LocaleConstant.USER_DETAIL_MODEL);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void login(String username, String key) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> loginObservable = RetrofitServiceManager.login(username, key);
        ObserverSubscriber.addSubscribe(loginObservable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        LoginResultBean loginResultBean = gson.fromJson(response, new TypeToken<LoginResultBean>() {
                        }.getType());
                        loginResult.setValue(loginResultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void loginOut() {
        Observable<ResponseBody> observable = RetrofitServiceManager.loginOut();
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean resultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        loginOutResult.setValue(resultBean);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void changePassword(String oldPwd, String newPwd) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> observable = RetrofitServiceManager.getChangePasswordResult(oldPwd, newPwd);
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean actionResultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        changePwdResult.setValue(actionResultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
